﻿// See https://aka.ms/new-console-template for more information
using EntityFramework;
using Microsoft.EntityFrameworkCore;

using ( var context = new LoLDbContext())
{
    context.Add(new ChampionEntity{ Name = "test", Bio = "test", Icon = "test" } );
    context.SaveChanges();

    ChampionEntity champ = context.Find<ChampionEntity>(1);

    if( champ != null)
    {
    Console
        .WriteLine(champ.ToString());

    }
    else
    {
        Console.WriteLine("Not Found");
    }

    //Test BDD Skills
    ChampionEntity champSkill = new ChampionEntity { Name="nomSkill", Bio="bioSkill", Icon="iconSkill" };

    SkillEntity s1 = new SkillEntity("Skill1", "desc", SkillType.Unknown);
    SkillEntity s2 = new SkillEntity("Skill2", "desc2", SkillType.Ultimate);
    SkillEntity s3 = new SkillEntity("Skill3", "desc3", SkillType.Passive);

    champSkill.AddSkill(s1);
    champSkill.AddSkill(s2);
    champSkill.AddSkill(s3);

    context.Add(champSkill);

    context.SaveChanges();


    //OneToMany
    Console.WriteLine("Champions : ");
    foreach (var champi in context.Champions.Include(a => a.skins))
    {
        Console.WriteLine($"\t{champi.Id}: {champi.Name} : {champi.Bio}");
        foreach (var s in champi.skins)
        {
            Console.WriteLine($"\t\t{s.Name}");
        }
    }

    Console.WriteLine();

    Console.WriteLine("Skin :");
    foreach (var s in context.Skins)
    {
        Console.WriteLine($"\t{s.Name}: {s.Description} (Champion : {s.Champion.Name})");
    }


    Console.WriteLine("\nAjout d'un Champion et 6 Skins...\n");

    ChampionEntity captainMarvel = new ChampionEntity { Name = "Captain Marvel", Bio="Mais que fait un avenger ici ??", Icon="Icon.png"};
    SkinEntity[] skins = {  new SkinEntity {Name = "La Fiesta", Champion = captainMarvel},
                        new SkinEntity { Name = "Five Hundred Miles High", Champion = captainMarvel },
                        new SkinEntity { Name = "Captain Marvel", Champion = captainMarvel },
                        new SkinEntity { Name = "Time's Lie", Champion = captainMarvel },
                        new SkinEntity { Name = "Lush Life", Champion = captainMarvel },
                        new SkinEntity { Name = "Day Waves", Champion = captainMarvel }
                    };
    foreach (var s in skins)
    {
        captainMarvel.skins.Add(s);
    }

    context.Add(captainMarvel);
    context.SaveChanges();


}
